package com.zksy.web.controller.basicData;


import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.TypeReference;
import com.zksy.common.core.controller.BaseController;
import com.zksy.common.core.domain.AjaxResult;
import com.zksy.common.utils.file.ExcelUtils;
import com.zksy.system.basicData.domain.CrmEnterpriseTechnologyRndSummary;
import com.zksy.system.basicData.service.CrmEnterpriseTechnologyRndSummaryService;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.zksy.utils.DowntemplateUtil;
import com.zksy.utils.MergeReadsExcelUtil;
import com.zksy.utils.SearchUtil;
import com.zksy.common.annotation.Log;
import com.zksy.common.enums.BusinessType;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;
import org.springframework.web.multipart.MultipartFile;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;
import java.util.Map;

/**
 * 企业科技研发信息汇总Controller
 *
 * @author sy
 * @date 2024-05-08
 */
@RestController
@RequestMapping("/crmEnterpriseTechnologyRndSummary")
@Api(tags = "企业科技研发信息汇总", description = "企业科技研发信息汇总desc")
public class CrmEnterpriseTechnologyRndSummaryController extends BaseController {

    @Autowired
    private CrmEnterpriseTechnologyRndSummaryService service;

    @GetMapping("/getById/{borrowId}")
    @ApiOperation(value = "企业科技研发信息汇总搜索getById")
    public AjaxResult getById(@PathVariable String borrowId) {
        return AjaxResult.success(service.getById(borrowId));
    }

    @GetMapping("/findByPage")
    @ApiOperation(value = "企业科技研发信息汇总分页")
    public Page findByPage(long pageNum, long pageSize, String conditionJson) throws Exception {
        return service.page(new Page<>(pageNum, pageSize), SearchUtil.parseWhereSql(conditionJson));
    }

    @GetMapping("/getList")
    @ApiOperation(value = "企业科技研发信息汇总查询所有")
    public AjaxResult getList(String conditionJson) throws Exception {
        return AjaxResult.success(service.list(SearchUtil.parseWhereSql(conditionJson)));
    }

    /**
     * 新增企业科技研发信息汇总
     */
    @PostMapping("/save")
    @ApiOperation(value = "企业科技研发信息汇总新增")
    @Log(title = "新增企业科技研发信息汇总", businessType = BusinessType.INSERT)
    public boolean save(@RequestBody CrmEnterpriseTechnologyRndSummary crmEnterpriseTechnologyRndSummary) {
        return service.save(crmEnterpriseTechnologyRndSummary);
    }

    /**
     * 修改企业科技研发信息汇总
     */
    @PostMapping("/updateById")
    @ApiOperation(value = "企业科技研发信息汇总修改")
    @Log(title = "修改企业科技研发信息汇总", businessType = BusinessType.UPDATE)
    public boolean updateById(@RequestBody CrmEnterpriseTechnologyRndSummary crmEnterpriseTechnologyRndSummary) {
        return service.updateById(crmEnterpriseTechnologyRndSummary);
    }

    /**
     * 导入企业科技研发信息汇总
     */
    @ApiOperation("企业科技研发信息汇总导入")
    @Log(title = "企业科技研发信息汇总", businessType = BusinessType.IMPORT)
    @PostMapping("/importData")
    public AjaxResult importData(MultipartFile file)
    {
        try {
            List<CrmEnterpriseTechnologyRndSummary> crmEnterpriseTechnologyRndSummaryAll = service.list();
            //List<CrmEnterpriseTechnologyRndSummary> list = ExcelUtils.readMultipartFile(file, CrmEnterpriseTechnologyRndSummary.class,CrmEnterpriseTechnologyRndSummary.class.getDeclaredFields().length - 2);
            if(crmEnterpriseTechnologyRndSummaryAll != null && crmEnterpriseTechnologyRndSummaryAll.size() > 0){
                //return AjaxResult.error("数据已存在，如需重新导入请清空数据");
            }
            //excel单元格合并导入
            //参数：文件， 表头列数， 是否读取序号0-读取、1-不读取， 表头占的行数下标从0开始的
            List<Map<String,String>> list = MergeReadsExcelUtil.readExcelToObj(file, CrmEnterpriseTechnologyRndSummary.class.getDeclaredFields().length - 2,1,2,CrmEnterpriseTechnologyRndSummary.class);
            List<CrmEnterpriseTechnologyRndSummary> crmEnterpriseTechnologyRndSummary= JSON.parseObject(JSON.toJSONString(list), new TypeReference<List<CrmEnterpriseTechnologyRndSummary>>() {});

            if(list.size() > 0){
                service.saveBatch(crmEnterpriseTechnologyRndSummary);
                return success("导入成功，共计："+list.size()+"条");
            }else{
                return AjaxResult.error("无数据");
            }
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导入数据失败");
        }
    }

    @ApiOperation("企业科技研发信息汇总导出")
    @Log(title = "企业科技研发信息汇总", businessType = BusinessType.EXPORT)
    @PostMapping("/exportData")
    public AjaxResult exportData(HttpServletResponse response, String conditionJson){
        try {
            List<CrmEnterpriseTechnologyRndSummary> wrapperList = service.list(SearchUtil.parseWhereSql(conditionJson));
            ExcelUtils.export(response,"企业科技研发信息汇总",wrapperList,CrmEnterpriseTechnologyRndSummary.class);
            return AjaxResult.success("导出数据成功");
        }catch (Exception e){
            e.printStackTrace();
            return AjaxResult.error("导出数据失败");
        }
    }

    @Log(title = "企业科技研发信息汇总", businessType = BusinessType.DELETE)
    @PostMapping("/delete")
    @ApiOperation(value = "删除企业科技研发信息汇总", notes = "删除企业科技研发信息汇总")
    public AjaxResult delete(@RequestBody List<String> ids)
    {
        return toAjax(service.removeByIds(ids));
    }

    @DeleteMapping("/deleteAll")
    @ApiOperation(value = "清除数据", notes = "清除数据")
    public AjaxResult deleteAll(){
        return service.deleteAll();
    }
    @PostMapping("/getUploadTemplate")
    @ApiOperation(value = "获取上传模板", notes = "获取上传模板")
    public void getUploadTemplate(HttpServletResponse response) throws IOException {
        DowntemplateUtil.downloadTemplate(response,"企业科技研发信息模板");
    }
}

